----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 10.04.2017 20:34:53
-- Design Name: 
-- Module Name: vga_neg - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity vga_neg is
    Port (
        BGR_neg         : in    STD_LOGIC_VECTOR(2 downto 0);
    
        VGA_clk_pix_in  : in    STD_LOGIC;
        VGA_red_in      : in    STD_LOGIC_VECTOR(7 downto 0);
        VGA_green_in    : in    STD_LOGIC_VECTOR(7 downto 0);
        VGA_blue_in     : in    STD_LOGIC_VECTOR(7 downto 0);
        VGA_hsync_in    : in    STD_LOGIC;
        VGA_vsync_in    : in    STD_LOGIC;
        VGA_blank_in    : in    STD_LOGIC;
        
        VGA_clk_pix_out : out   STD_LOGIC := '0';
        VGA_red_out     : out   STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
        VGA_green_out   : out   STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
        VGA_blue_out    : out   STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
        VGA_hsync_out   : out   STD_LOGIC := '0';
        VGA_vsync_out   : out   STD_LOGIC := '0';
        VGA_blank_out   : out   STD_LOGIC := '0'
    );
end vga_neg;

architecture Behavioral of vga_neg is

begin

    VGA_clk_pix_out <= VGA_clk_pix_in;
    
    process(VGA_clk_pix_in)
    begin
        if rising_edge(VGA_clk_pix_in) then
            VGA_hsync_out   <= VGA_hsync_in;
            VGA_vsync_out   <= VGA_vsync_in;
            VGA_blank_out   <= VGA_blank_in;
        
            if BGR_neg(0) = '0' then
                VGA_red_out <= VGA_red_in;
            else
                VGA_red_out <= not VGA_red_in;
            end if;
            
            if BGR_neg(1) = '0' then
                VGA_green_out <= VGA_green_in;
            else
                VGA_green_out <= not VGA_green_in;
            end if;
            
            if BGR_neg(2) = '0' then
                VGA_blue_out <= VGA_blue_in;
            else
                VGA_blue_out <= not VGA_blue_in;
            end if;
        end if;
    end process;

end Behavioral;
